import calendar
from datetime import timedelta, datetime


def filter_weekend(day):
    while calendar.weekday(day.year, day.month, day.day) in [5, 6]:
        day = day - timedelta(1)
    return day


def next_workday(day):
    result = day
    while result == day or result.weekday() in [5, 6]:
        result = result + timedelta(1)
    return result


def is_workday(day):
    return day.weekday() in range(5)


def format_date(date, has_time=False):
    return date.strftime('%Y-%m-%d %H:%M:%S' if has_time else '%Y-%m-%d')


def parse_date(date, has_time=False):
    return datetime.strptime(date, '%Y-%m-%d %H:%M:%S' if has_time else '%Y-%m-%d')


if __name__ == '__main__':
    print(parse_date('2022-10-01 10:24:24', has_time=True))
