import json
from framework import read, write, where, format_date


__COLUMNS__ = {
    'rop_id': 'id',
    'rop_date': 'date',
    'rop_fund_ids': 'fund_ids',
}


@read
def get_list(*args, **kwargs):
    return f'''select {','.join([f"`{x[0]}` as `{x[1]}`" for x in __COLUMNS__.items()])} from robo_optimize_pool {where(*args, **kwargs)}'''


@read(one=True)
def get_one(*args, **kwargs):
    return f'''select {','.join([f"`{x[0]}` as `{x[1]}`" for x in __COLUMNS__.items()])} from robo_optimize_pool {where(*args, **kwargs)}'''


@read(one=True)
def get_last_one(day=None):
    sql = f"rop_date <= '{format_date(day)}'" if day else None
    return f'''select {','.join([f"`{x[0]}` as `{x[1]}`" for x in __COLUMNS__.items()])} from robo_optimize_pool {where(sql)} order by rop_date desc limit 1'''


@write
def insert(day, pool):
    return f'''
        insert into robo_optimize_pool(rop_date, rop_fund_ids)
        values ('{format_date(day)}', '{json.dumps(pool) if isinstance(pool, dict) else pool}')
    '''
